#' @export
directions <- function(dr, k) {
    UseMethod("directions")
}

#' Computes projected training data \code{X} for given dimension `k`.
#'
#' @param dr Instance of 'cve' as returned by \code{cve}.
#' @param k SDR dimension to use for projection.
#'
#' @method directions cve
#' @aliases directions directions.cve
#' @export
directions.cve <- function(dr, k) {
    if (!(k %in% names(dr$res))) {
        stop("SDR directions for requested dimension `k` not computed.")
    }
    return(dr$X %*% dr$res[[as.character(k)]]$B)
}
