% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coef.R
\name{coef.cve}
\alias{coef.cve}
\title{Gets estimated SDR basis.}
\usage{
\method{coef}{cve}(object, k, ...)
}
\arguments{
\item{object}{instance of \code{cve} as output from \code{\link{cve}} or
\code{\link{cve.call}}}

\item{k}{the SDR dimension.}

\item{...}{ignored.}
}
\value{
dir the matrix of CS or CMS of given dimension
}
\description{
Returns the SDR basis matrix for SDR dimension(s).
}
\examples{
x <- matrix(rnorm(400),100,4)
y <- x[, 1] + x[, 2] + as.matrix(rnorm(100))
dr <- cve(y ~ x, k = 2) # Only for sub-space dim. 2
B2 <- coef(dr, 2)

}
